using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;

using Einhugur.Encoders.yEnc;

namespace yEncTester
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.ListBox lstLog;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.lstLog = new System.Windows.Forms.ListBox();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(8, 24);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(168, 24);
			this.button1.TabIndex = 0;
			this.button1.Text = "Encode Into Single file...";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(8, 56);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(168, 24);
			this.button2.TabIndex = 1;
			this.button2.Text = "Encode multiple parts...";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// lstLog
			// 
			this.lstLog.Location = new System.Drawing.Point(8, 96);
			this.lstLog.Name = "lstLog";
			this.lstLog.Size = new System.Drawing.Size(528, 212);
			this.lstLog.TabIndex = 2;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(544, 318);
			this.Controls.Add(this.lstLog);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs args)
		{
			OpenFileDialog dlg;
			SaveFileDialog saveDlg;
			YEncEncoder yenc;
			FileInfo destination;
			FileInfo source;
			
			dlg = new OpenFileDialog();
			dlg.Title = "Select source file to decode...";


			if(dlg.ShowDialog() == DialogResult.OK)
			{
				source = new FileInfo(dlg.FileName);

				saveDlg = new SaveFileDialog();
				saveDlg.Title = "Save encoded file as...";

				if(!(saveDlg.ShowDialog() == DialogResult.OK))
					return;

				destination = new FileInfo(saveDlg.FileName);

				lstLog.Items.Clear();

				try
				{
					yenc = new YEncEncoder();

					yenc.EncodeToFile(source,destination);
					lstLog.Items.Add("Encoded the file "+ source.Name + " to the file " + destination.Name);
				}
				catch(YEncException e)
				{
					MessageBox.Show(e.Message);
				}
			}
		}

		private void button2_Click(object sender, System.EventArgs args)
		{
			OpenFileDialog dlg;
			YEncEncoder yenc = null;
			FileInfo source;
			FileInfo destination;
			int partCount = 0;

			dlg = new OpenFileDialog();
			dlg.Title = "Select source file to decode...";


			if(dlg.ShowDialog() == DialogResult.OK)
			{
				source = new FileInfo(dlg.FileName);

				lstLog.Items.Clear();

				try
				{
					yenc = new YEncEncoder();

					yenc.BeginMultiPart(source,11250);
					lstLog.Items.Add("Started encoding the file " + source.Name + " to multipart yEnc files.");

					while(!yenc.PartsDone)
					{
						partCount++;
						destination = new FileInfo(source.Directory.Name +"MyYencFile_Part" + partCount.ToString());

						yenc.EncodePartToFile(destination);

						lstLog.Items.Add("Wrote part number " + partCount.ToString() + " into file " + destination.Name);
				
					}
				}
				catch(YEncException e)
				{
					MessageBox.Show(e.Message);
				}
				finally
				{
					// We need to call EndMultiPart even if encoding failed.
					if(yenc != null)
						yenc.EndMultiPart();
					lstLog.Items.Add("Finished encoding the file " + source.Name + " to multipart yEnc files.");
				}
			}
		}
	}
}
